/* The following code was generated by JFlex 1.6.1 */

/*******************************************************************************
 * Copyright (c) 2006, 2017 Zend Corporation and IBM Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Zend and IBM - Initial implementation
 *******************************************************************************/

package org.eclipse.php.internal.core.ast.scanner.php5;

import java.io.IOException;
import java.util.LinkedList;
import java.util.Stack;

import org.eclipse.php.core.PHPVersion;
import org.eclipse.php.core.ast.nodes.AST;
import org.eclipse.php.core.ast.nodes.Comment;
import org.eclipse.php.core.ast.nodes.IDocumentorLexer;
import org.eclipse.php.internal.core.util.collections.StateStack;

import java_cup.sym;
import java_cup.runtime.Symbol;


/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.6.1
 * from the specification file <tt>ast_scanner.flex</tt>
 */
public class PHPAstLexer implements org.eclipse.php.internal.core.ast.scanner.AstLexer {

	/** This character denotes the end of file */
	public static final int YYEOF = -1;

	/** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

	/** lexical states */
  public static final int YYINITIAL = 0;
  public static final int ST_IN_SCRIPTING = 2;
  public static final int ST_DOUBLE_QUOTES = 4;
  public static final int ST_SINGLE_QUOTE = 6;
  public static final int ST_BACKQUOTE = 8;
  public static final int ST_HEREDOC = 10;
  public static final int ST_START_HEREDOC = 12;
  public static final int ST_END_HEREDOC = 14;
  public static final int ST_LOOKING_FOR_PROPERTY = 16;
  public static final int ST_LOOKING_FOR_VARNAME = 18;
  public static final int ST_VAR_OFFSET = 20;
  public static final int ST_COMMENT = 22;
  public static final int ST_DOCBLOCK = 24;
  public static final int ST_ONE_LINE_COMMENT = 26;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13
  };

  /** 
   * Translates characters to character classes
   */
  private static final String ZZ_CMAP_PACKED = 
    "\11\0\1\12\1\11\2\0\1\13\22\0\1\12\1\57\1\15\1\100"+
    "\1\14\1\63\1\64\1\77\1\50\1\52\1\61\1\4\1\67\1\44"+
    "\1\2\1\62\1\5\11\1\1\46\1\21\1\60\1\56\1\45\1\73"+
    "\1\74\1\35\1\7\1\30\1\24\1\3\1\25\1\51\1\36\1\22"+
    "\1\53\1\41\1\40\1\43\1\27\1\31\1\42\1\55\1\33\1\32"+
    "\1\23\1\26\1\47\1\37\1\6\1\34\1\10\1\70\1\16\1\71"+
    "\1\66\1\54\1\17\1\35\1\7\1\30\1\24\1\3\1\25\1\51"+
    "\1\36\1\22\1\53\1\41\1\40\1\43\1\27\1\31\1\42\1\55"+
    "\1\33\1\76\1\23\1\26\1\47\1\37\1\6\1\34\1\10\1\20"+
    "\1\65\1\75\1\72\261\10\2\22\115\10\1\32\u1faa\10\1\41\uded5\10"+
    "\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\uffff\0\20\0";

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\5\0\1\1\10\0\2\2\1\3\1\4\1\5\1\6"+
    "\1\7\1\4\3\6\1\10\1\11\1\12\1\13\1\14"+
    "\1\15\16\6\1\16\1\17\1\20\1\6\1\21\1\6"+
    "\1\22\1\6\1\23\1\24\1\25\1\26\1\27\1\30"+
    "\1\31\1\32\1\33\1\34\1\35\1\36\1\37\1\40"+
    "\1\41\1\42\1\43\1\44\1\1\1\3\1\45\2\3"+
    "\1\46\1\3\1\47\1\1\2\3\1\50\1\3\2\1"+
    "\3\3\2\51\1\3\1\52\1\53\1\52\1\54\1\55"+
    "\1\56\1\5\1\7\1\56\1\57\1\60\1\61\1\62"+
    "\1\16\1\17\1\20\1\21\1\23\1\24\1\25\1\26"+
    "\1\27\1\30\1\31\1\32\1\33\1\63\1\40\1\64"+
    "\1\10\1\65\3\10\3\66\2\65\1\0\1\67\1\70"+
    "\1\2\1\71\1\0\1\72\6\6\1\73\1\74\1\0"+
    "\2\6\2\0\1\75\2\0\1\76\2\0\1\77\7\6"+
    "\1\100\11\6\1\101\5\6\1\102\5\6\1\103\1\104"+
    "\1\105\1\106\1\107\1\110\1\6\12\0\2\6\1\111"+
    "\1\112\2\113\1\114\1\115\1\0\1\116\1\117\1\120"+
    "\1\121\1\122\1\123\1\124\1\125\1\126\1\127\1\130"+
    "\4\0\1\75\2\131\1\132\1\133\1\131\1\0\1\134"+
    "\3\0\2\131\3\0\1\1\2\131\1\0\1\135\2\0"+
    "\1\136\1\0\1\137\1\140\1\0\1\141\1\142\1\143"+
    "\1\144\2\0\1\71\1\0\7\6\1\71\1\145\1\6"+
    "\1\0\5\6\1\146\3\6\1\147\2\6\1\150\1\6"+
    "\1\151\1\152\12\6\1\153\6\6\1\154\1\155\12\0"+
    "\6\6\1\156\1\157\1\160\3\0\1\161\2\0\1\162"+
    "\1\163\1\1\1\140\2\0\6\6\1\164\1\165\1\6"+
    "\1\166\21\6\1\167\11\6\1\170\4\6\12\0\7\6"+
    "\2\0\1\171\4\0\1\6\1\172\5\6\1\173\1\174"+
    "\3\6\1\175\1\6\1\176\3\6\1\177\2\6\1\200"+
    "\1\6\1\201\1\202\1\203\1\204\5\6\1\205\1\206"+
    "\1\6\1\207\2\6\4\0\1\210\7\0\7\6\2\211"+
    "\2\0\1\212\2\213\1\0\2\6\1\214\2\6\1\215"+
    "\4\6\1\216\5\6\1\217\1\220\1\221\2\6\1\222"+
    "\2\6\3\0\1\223\5\0\1\224\1\0\1\225\6\6"+
    "\3\0\1\226\5\6\1\227\2\6\1\230\1\231\1\6"+
    "\1\232\1\6\1\233\1\6\1\234\1\6\3\0\1\235"+
    "\1\0\1\236\6\6\3\0\3\6\1\237\4\6\1\240"+
    "\1\241\1\6\1\242\1\6\1\243\1\244\1\245\3\6"+
    "\1\246\1\6\5\0\2\6\1\247\1\250\4\6\1\251"+
    "\1\6\1\252\2\6\3\0\1\253\1\254\1\6\1\255"+
    "\1\256\3\6\1\257\3\0\4\6\4\0\1\260\1\261"+
    "\1\262\1\6\3\0\1\6\1\263\1\0\1\6\1\0"+
    "\1\264\14\0\1\70\1\0";

  private static int [] zzUnpackAction() {
    int [] result = new int[639];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\101\0\202\0\303\0\u0104\0\u0145\0\u0186\0\u01c7"+
    "\0\u0208\0\u0249\0\u028a\0\u02cb\0\u030c\0\u034d\0\u038e\0\u03cf"+
    "\0\u0410\0\u0451\0\u0492\0\u04d3\0\u0514\0\u0555\0\u0596\0\u05d7"+
    "\0\u0618\0\u0659\0\u069a\0\u06db\0\u0410\0\u0410\0\u0410\0\u071c"+
    "\0\u075d\0\u079e\0\u07df\0\u0820\0\u0861\0\u08a2\0\u08e3\0\u0924"+
    "\0\u0965\0\u09a6\0\u09e7\0\u0a28\0\u0a69\0\u0aaa\0\u0aeb\0\u0b2c"+
    "\0\u0b6d\0\u0bae\0\u0bef\0\u0410\0\u0c30\0\u0c71\0\u0cb2\0\u0cf3"+
    "\0\u0d34\0\u0d75\0\u0db6\0\u0df7\0\u0e38\0\u0e79\0\u0410\0\u0410"+
    "\0\u0410\0\u0410\0\u0eba\0\u0410\0\u0410\0\u0efb\0\u0410\0\u0f3c"+
    "\0\u0f7d\0\u0410\0\u0fbe\0\u0fff\0\u1040\0\u1081\0\u0410\0\u10c2"+
    "\0\u1103\0\u1144\0\u0410\0\u1185\0\u11c6\0\u1207\0\u1248\0\u1289"+
    "\0\u12ca\0\u0410\0\u130b\0\u134c\0\u0410\0\u138d\0\u13ce\0\u0410"+
    "\0\u140f\0\u1450\0\u0410\0\u0410\0\u1491\0\u0410\0\u0410\0\u0410"+
    "\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410"+
    "\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410"+
    "\0\u0410\0\u14d2\0\u1513\0\u0410\0\u1554\0\u1595\0\u15d6\0\u0410"+
    "\0\u1617\0\u0410\0\u1658\0\u1699\0\u16da\0\u171b\0\u175c\0\u179d"+
    "\0\u17de\0\u0410\0\u181f\0\u1860\0\u18a1\0\u18e2\0\u1923\0\u1964"+
    "\0\u0410\0\u0410\0\u19a5\0\u19e6\0\u1a27\0\u1a68\0\u0efb\0\u1aa9"+
    "\0\u06db\0\u1aea\0\u0410\0\u1b2b\0\u1b6c\0\u0618\0\u1bad\0\u1bee"+
    "\0\u1c2f\0\u1c70\0\u1cb1\0\u1cf2\0\u1d33\0\u0618\0\u1d74\0\u1db5"+
    "\0\u1df6\0\u1e37\0\u1e78\0\u1eb9\0\u1efa\0\u1f3b\0\u1f7c\0\u0618"+
    "\0\u1fbd\0\u1ffe\0\u203f\0\u2080\0\u20c1\0\u0618\0\u2102\0\u2143"+
    "\0\u2184\0\u21c5\0\u2206\0\u0410\0\u0410\0\u0410\0\u2247\0\u0410"+
    "\0\u0410\0\u2288\0\u22c9\0\u0bae\0\u230a\0\u234b\0\u238c\0\u23cd"+
    "\0\u240e\0\u244f\0\u2490\0\u24d1\0\u2512\0\u2553\0\u0410\0\u2594"+
    "\0\u25d5\0\u0410\0\u0410\0\u2616\0\u2657\0\u0410\0\u0410\0\u2698"+
    "\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410\0\u0410"+
    "\0\u26d9\0\u271a\0\u0fbe\0\u275b\0\u279c\0\u271a\0\u0410\0\u0410"+
    "\0\u0410\0\u275b\0\u27dd\0\u0410\0\u281e\0\u1144\0\u285f\0\u281e"+
    "\0\u285f\0\u28a0\0\u1289\0\u28e1\0\u2922\0\u28a0\0\u28e1\0\u130b"+
    "\0\u0410\0\u2963\0\u134c\0\u0410\0\u29a4\0\u0410\0\u29e5\0\u2a26"+
    "\0\u0410\0\u0410\0\u0410\0\u0410\0\u2a67\0\u2aa8\0\u2ae9\0\u2ae9"+
    "\0\u2b2a\0\u2b6b\0\u2bac\0\u2bed\0\u2c2e\0\u2c6f\0\u2cb0\0\u19a5"+
    "\0\u0618\0\u2cf1\0\u2d32\0\u2d73\0\u2db4\0\u2df5\0\u2e36\0\u2e77"+
    "\0\u0618\0\u2eb8\0\u2ef9\0\u2f3a\0\u0618\0\u2f7b\0\u2fbc\0\u2ffd"+
    "\0\u303e\0\u0618\0\u0618\0\u307f\0\u30c0\0\u3101\0\u3142\0\u3183"+
    "\0\u31c4\0\u3205\0\u3246\0\u3287\0\u32c8\0\u0618\0\u3309\0\u334a"+
    "\0\u338b\0\u33cc\0\u340d\0\u344e\0\u0410\0\u0618\0\u348f\0\u34d0"+
    "\0\u3511\0\u3552\0\u3593\0\u35d4\0\u3615\0\u3656\0\u3697\0\u36d8"+
    "\0\u3719\0\u375a\0\u379b\0\u37dc\0\u381d\0\u385e\0\u0410\0\u0410"+
    "\0\u0410\0\u389f\0\u38e0\0\u3921\0\u3962\0\u39a3\0\u39e4\0\u0410"+
    "\0\u0410\0\u3a25\0\u2a26\0\u3a66\0\u3aa7\0\u3ae8\0\u3b29\0\u3b6a"+
    "\0\u3bab\0\u3bec\0\u3c2d\0\u0618\0\u3c6e\0\u3caf\0\u0618\0\u3cf0"+
    "\0\u3d31\0\u3d72\0\u3db3\0\u3df4\0\u3e35\0\u3e76\0\u3eb7\0\u3ef8"+
    "\0\u3f39\0\u3f7a\0\u3fbb\0\u3ffc\0\u403d\0\u407e\0\u40bf\0\u4100"+
    "\0\u0618\0\u4141\0\u4182\0\u41c3\0\u4204\0\u4245\0\u4286\0\u42c7"+
    "\0\u4308\0\u4349\0\u0618\0\u438a\0\u43cb\0\u440c\0\u444d\0\u448e"+
    "\0\u44cf\0\u4510\0\u4551\0\u4592\0\u45d3\0\u4614\0\u4655\0\u4696"+
    "\0\u46d7\0\u4718\0\u4759\0\u479a\0\u47db\0\u481c\0\u485d\0\u489e"+
    "\0\u48df\0\u4920\0\u0410\0\u4961\0\u49a2\0\u49e3\0\u4a24\0\u4a65"+
    "\0\u0618\0\u4aa6\0\u4ae7\0\u4b28\0\u4b69\0\u4baa\0\u0618\0\u0618"+
    "\0\u4beb\0\u4c2c\0\u4c6d\0\u0618\0\u4cae\0\u0618\0\u4cef\0\u4d30"+
    "\0\u4d71\0\u0618\0\u4db2\0\u4df3\0\u0618\0\u4e34\0\u0618\0\u0618"+
    "\0\u0618\0\u0618\0\u4e75\0\u4eb6\0\u4ef7\0\u4f38\0\u4f79\0\u0618"+
    "\0\u0618\0\u4fba\0\u0618\0\u4ffb\0\u503c\0\u507d\0\u50be\0\u50ff"+
    "\0\u5140\0\u0410\0\u5181\0\u51c2\0\u5203\0\u5244\0\u5285\0\u52c6"+
    "\0\u5307\0\u5348\0\u5389\0\u53ca\0\u540b\0\u544c\0\u548d\0\u54ce"+
    "\0\u0410\0\u550f\0\u5550\0\u5591\0\u0410\0\u0410\0\u55d2\0\u5613"+
    "\0\u5654\0\u5695\0\u56d6\0\u5717\0\u5758\0\u0618\0\u5799\0\u57da"+
    "\0\u581b\0\u585c\0\u0618\0\u589d\0\u58de\0\u591f\0\u5960\0\u59a1"+
    "\0\u0618\0\u0618\0\u0618\0\u59e2\0\u5a23\0\u0618\0\u5a64\0\u5aa5"+
    "\0\u5ae6\0\u5b27\0\u5b68\0\u0410\0\u5ba9\0\u5bea\0\u5c2b\0\u5c6c"+
    "\0\u5cad\0\u0410\0\u5cee\0\u0618\0\u5d2f\0\u5d70\0\u5db1\0\u5df2"+
    "\0\u5e33\0\u5e74\0\u5eb5\0\u5ef6\0\u5f37\0\u0618\0\u5f78\0\u5fb9"+
    "\0\u5ffa\0\u603b\0\u607c\0\u60bd\0\u60fe\0\u613f\0\u0618\0\u0618"+
    "\0\u6180\0\u0618\0\u61c1\0\u6202\0\u6243\0\u0618\0\u6284\0\u62c5"+
    "\0\u6306\0\u6347\0\u0410\0\u6388\0\u0410\0\u63c9\0\u640a\0\u644b"+
    "\0\u648c\0\u64cd\0\u650e\0\u654f\0\u6590\0\u65d1\0\u6612\0\u6653"+
    "\0\u6694\0\u0618\0\u66d5\0\u6716\0\u6757\0\u6798\0\u0618\0\u0618"+
    "\0\u67d9\0\u0618\0\u681a\0\u0410\0\u0410\0\u0618\0\u685b\0\u689c"+
    "\0\u68dd\0\u0618\0\u691e\0\u695f\0\u69a0\0\u69e1\0\u6a22\0\u6a63"+
    "\0\u6aa4\0\u6ae5\0\u0618\0\u0618\0\u6b26\0\u6b67\0\u6ba8\0\u6be9"+
    "\0\u0618\0\u6c2a\0\u0618\0\u6c6b\0\u6cac\0\u6ced\0\u6d2e\0\u6d6f"+
    "\0\u0618\0\u0618\0\u6db0\0\u0618\0\u0618\0\u6df1\0\u6e32\0\u6e73"+
    "\0\u0618\0\u6eb4\0\u6ef5\0\u6f36\0\u6f77\0\u6fb8\0\u6ff9\0\u703a"+
    "\0\u707b\0\u70bc\0\u70fd\0\u713e\0\u0618\0\u0618\0\u0618\0\u717f"+
    "\0\u71c0\0\u7201\0\u7242\0\u7283\0\u0410\0\u72c4\0\u7305\0\u7346"+
    "\0\u0618\0\u7387\0\u73c8\0\u7409\0\u744a\0\u748b\0\u74cc\0\u750d"+
    "\0\u754e\0\u758f\0\u75d0\0\u7611\0\u7652\0\u0410\0\u7693";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[639];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\60\17\1\20\20\17\1\21\1\22\1\23\1\24\1\25"+
    "\1\26\1\27\1\30\1\31\3\32\1\33\1\34\1\21"+
    "\1\35\1\36\1\37\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\31\1\52\1\31"+
    "\1\53\1\54\1\31\1\55\1\31\1\56\1\57\1\60"+
    "\1\61\1\62\1\63\1\64\1\31\1\65\1\31\1\66"+
    "\1\67\1\70\1\71\1\72\1\73\1\74\1\75\1\76"+
    "\1\77\1\100\1\101\1\102\1\103\1\104\1\105\1\50"+
    "\1\106\1\107\14\110\1\111\1\112\1\113\1\110\1\114"+
    "\60\110\16\115\1\116\60\115\1\117\1\115\14\120\1\121"+
    "\1\120\1\122\1\123\1\124\60\120\11\125\1\126\1\125"+
    "\1\126\1\127\1\125\1\130\1\125\1\131\60\125\3\132"+
    "\1\133\2\132\3\133\11\132\22\133\3\132\1\133\1\132"+
    "\1\133\1\132\3\133\20\132\1\133\2\132\3\21\1\134"+
    "\2\21\3\134\11\21\22\134\3\21\1\134\1\21\1\134"+
    "\1\21\3\134\20\21\1\134\2\21\3\135\1\136\2\135"+
    "\3\136\11\135\22\136\1\137\2\135\1\136\1\135\1\136"+
    "\1\135\3\136\20\135\1\136\2\135\3\140\1\141\2\140"+
    "\3\141\11\140\22\141\3\140\1\141\1\140\1\141\1\140"+
    "\3\141\20\140\1\141\2\140\1\21\1\142\1\143\1\31"+
    "\1\144\1\145\3\31\3\146\1\33\1\147\1\146\1\150"+
    "\1\151\1\37\22\31\1\152\1\153\1\154\1\31\1\155"+
    "\1\31\1\64\3\31\1\156\1\157\1\160\1\161\1\162"+
    "\1\163\1\164\1\165\1\166\1\77\1\100\1\167\1\102"+
    "\1\170\1\104\1\171\1\31\2\146\61\172\1\173\17\172"+
    "\13\174\1\175\45\174\1\176\17\174\11\177\1\200\1\177"+
    "\1\201\31\177\1\202\15\177\1\203\7\177\1\203\5\177"+
    "\60\17\1\204\100\17\1\0\2\17\1\205\7\17\1\206"+
    "\2\17\1\207\2\17\102\0\1\22\1\210\1\211\1\0"+
    "\1\22\74\0\1\210\3\0\1\210\50\0\1\212\23\0"+
    "\1\31\1\0\1\31\1\0\1\31\1\213\2\31\11\0"+
    "\5\31\1\214\1\215\7\31\1\216\2\31\1\217\3\0"+
    "\1\220\1\0\1\31\1\0\3\31\20\0\1\31\6\0"+
    "\1\221\51\0\1\222\23\0\1\22\1\210\1\211\1\0"+
    "\1\22\1\223\73\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\224\12\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\4\0\1\34\4\0\11\31\1\225\10\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\2\0\1\226"+
    "\15\0\1\31\1\227\2\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\22\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\13\0\3\32\70\0\1\230\2\0"+
    "\3\230\11\0\22\230\3\0\1\230\1\0\1\230\1\0"+
    "\3\230\20\0\1\230\2\0\14\231\1\232\1\233\1\234"+
    "\1\231\1\235\60\231\1\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\3\31\1\236\1\31\1\237\2\31\1\240"+
    "\10\31\1\241\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\240\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\11\31\1\242\2\31\1\243\5\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\244\1\0\4\31\11\0\1\245\6\31\1\246"+
    "\12\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\1\247\3\31\1\250\2\31\1\251\12\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\5\31\1\252\2\31"+
    "\1\253\11\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\253\3\0\1\31\1\0\1\254\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\255\3\31\1\256\2\31\1\257\3\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\11\31"+
    "\1\260\10\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\1\31\1\261\13\31\1\262\4\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\263\1\0\4\31\11\0\22\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\2\31\1\264\1\31\11\0\5\31"+
    "\1\265\2\31\1\266\1\267\10\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\266\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\14\31\1\270\5\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\271\21\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\4\31"+
    "\1\272\4\31\1\273\10\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\46\0\1\274\1\275\10\0"+
    "\1\276\67\0\1\277\10\0\1\300\70\0\1\301\33\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\13\31\1\302"+
    "\6\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\11\0\1\303\2\0\1\304\7\0\1\305\1\0"+
    "\1\306\1\307\1\310\2\0\1\311\1\312\1\313\1\0"+
    "\1\314\40\0\1\312\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\16\31\1\315\3\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\1\31\1\316\1\31\20\0\1\31\47\0"+
    "\1\317\10\0\1\320\100\0\1\321\67\0\1\322\10\0"+
    "\1\323\1\0\1\324\1\0\1\325\74\0\1\326\100\0"+
    "\1\327\2\0\1\330\1\107\63\0\1\331\10\0\1\332"+
    "\100\0\1\333\5\0\1\334\72\0\1\335\6\0\1\336"+
    "\71\0\1\337\67\0\1\340\33\0\16\227\1\341\60\227"+
    "\1\233\1\227\14\110\1\342\1\0\1\343\1\110\1\344"+
    "\63\110\1\345\2\110\3\345\3\110\1\346\1\347\1\343"+
    "\1\110\1\350\1\110\22\345\3\110\1\345\1\110\1\345"+
    "\1\110\3\345\20\110\1\345\117\110\1\351\1\347\1\343"+
    "\1\110\1\352\60\110\16\115\1\353\60\115\1\0\17\115"+
    "\1\354\60\115\1\354\1\115\14\120\1\355\1\120\1\356"+
    "\1\0\1\357\63\120\1\345\2\120\3\345\3\120\1\360"+
    "\1\120\1\356\1\347\1\350\1\120\22\345\3\120\1\345"+
    "\1\120\1\345\1\120\3\345\20\120\1\345\117\120\1\351"+
    "\1\120\1\356\1\347\1\361\60\120\11\125\1\126\1\125"+
    "\1\126\1\362\1\125\1\363\1\125\1\364\63\125\1\365"+
    "\2\125\3\365\1\126\1\125\1\126\1\362\1\125\1\363"+
    "\1\125\1\364\1\125\22\365\3\125\1\365\1\125\1\365"+
    "\1\125\3\365\20\125\1\365\5\125\1\345\2\125\3\345"+
    "\1\126\1\125\1\126\1\366\1\125\1\363\1\125\1\350"+
    "\1\125\22\345\3\125\1\345\1\125\1\345\1\125\3\345"+
    "\20\125\1\345\13\125\1\126\1\125\1\126\76\125\1\126"+
    "\1\125\1\126\1\351\1\125\1\363\1\125\1\367\60\125"+
    "\1\0\1\370\1\0\1\370\1\0\4\370\1\371\1\0"+
    "\1\371\5\0\1\372\22\370\3\0\1\370\1\0\1\370"+
    "\1\0\3\370\20\0\1\370\3\0\1\373\1\0\1\373"+
    "\1\0\4\373\1\374\1\0\1\374\5\0\1\375\22\373"+
    "\3\0\1\373\1\0\1\373\1\0\3\373\20\0\1\373"+
    "\3\0\1\136\1\0\1\136\1\0\4\136\11\0\22\136"+
    "\3\0\1\136\1\0\1\136\1\0\3\136\20\0\1\136"+
    "\47\0\1\376\34\0\1\141\1\0\1\141\1\0\4\141"+
    "\11\0\22\141\3\0\1\141\1\0\1\141\1\0\3\141"+
    "\20\0\1\141\3\0\1\142\3\0\1\142\74\0\1\377"+
    "\3\0\1\377\1\u0100\72\0\61\172\1\0\17\172\62\0"+
    "\1\u0101\27\0\1\174\151\0\1\u0102\16\0\11\177\1\200"+
    "\1\177\1\201\31\177\1\200\15\177\1\200\7\177\1\200"+
    "\5\177\11\0\1\200\134\0\1\u0103\33\0\60\17\1\0"+
    "\2\17\1\0\7\17\1\0\2\17\1\0\2\17\56\0"+
    "\1\u0104\64\0\1\u0105\13\0\1\u0104\52\0\1\u0106\51\0"+
    "\1\210\1\0\1\211\1\0\1\210\74\0\1\u0107\2\0"+
    "\1\u0108\1\u0107\36\0\1\u0108\35\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\u0109\1\u010a\20\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\2\31\1\u010b\17\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\14\31"+
    "\1\u010c\5\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\10\31\1\u010d\11\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\u010d\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\20\31\1\u010e\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\13\31\1\u010f\6\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\u0110\1\0\1\u0110\1\0\1\u0110\1\0\1\u0110"+
    "\14\0\2\u0110\2\0\1\u0110\4\0\1\u0110\44\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\11\31\1\u0111\10\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\u0112\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\62\0\1\u0113\21\0\1\230\1\0\1\230\1\0\4\230"+
    "\11\0\22\230\3\0\1\230\1\0\1\230\1\0\3\230"+
    "\20\0\1\230\2\0\3\231\1\0\2\231\3\0\3\231"+
    "\1\232\1\233\1\234\1\231\1\0\1\231\22\0\3\231"+
    "\1\0\1\231\1\0\1\231\3\0\20\231\1\0\117\231"+
    "\1\0\1\233\1\234\1\231\1\235\60\231\1\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\1\31\1\u0114\4\31"+
    "\1\u0115\1\31\1\u0116\11\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\u0116\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\10\31\1\u0117\11\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\u0117\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\20\31\1\u0118\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\12\31"+
    "\1\u0119\7\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\11\31\1\u011a\10\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\3\31\1\u011b\2\31\1\u011c\13\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\u011d\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\5\31"+
    "\1\u011e\14\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\5\31\1\u011f\14\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\11\31\1\u0120\10\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\10\31\1\u0121\11\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\u0121"+
    "\3\0\1\31\1\0\1\u0122\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\15\31"+
    "\1\u0123\4\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\5\31\1\u0124\14\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\31\1\u0125\6\31\1\u0126\11\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\u0126"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\7\31"+
    "\1\u0127\3\31\1\u0128\6\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\13\31\1\u0129\6\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\1\u012a\21\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\31\1\u012b"+
    "\20\31\3\0\1\31\1\0\1\31\1\0\2\31\1\u012c"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\10\31\1\u012d\11\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\u012d\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\2\31\1\u012e\17\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\11\31\1\u012f\10\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\1\u0130"+
    "\21\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\10\31\1\u0131\11\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\u0131\3\0\1\31\1\0\1\31\1\0"+
    "\2\31\1\u0132\1\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\u0133\6\31\1\u0134\12\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\60\0\1\u0135\23\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\11\31\1\u0136\10\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\24\0\1\u0137\6\0\1\u0138"+
    "\76\0\1\u0139\102\0\1\u013a\107\0\1\u013b\67\0\1\u013c"+
    "\60\0\1\u013d\114\0\1\u013e\60\0\1\u013f\130\0\1\u0140"+
    "\46\0\1\31\1\0\1\31\1\0\4\31\11\0\7\31"+
    "\1\u0141\12\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\3\31\1\u0142\2\31\1\u0143\5\31\1\u0144\1\31"+
    "\1\u0145\2\31\1\u0146\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\60\0\1\u0147\100\0\1\u0148\100\0"+
    "\1\u0149\1\0\1\u014a\52\0\1\u014b\43\0\1\u014b\13\0"+
    "\3\u014c\45\0\1\u014d\12\0\1\u014e\4\0\101\227\3\110"+
    "\1\0\2\110\3\0\3\110\1\346\1\347\1\343\1\110"+
    "\1\0\1\110\22\0\3\110\1\0\1\110\1\0\1\110"+
    "\3\0\20\110\1\0\16\110\1\0\1\347\1\343\1\110"+
    "\1\352\60\110\1\0\1\345\1\0\1\345\1\0\4\345"+
    "\11\0\22\345\1\u014f\2\0\1\345\1\0\1\345\1\0"+
    "\3\345\12\0\1\u0150\5\0\1\345\2\0\16\115\1\0"+
    "\60\115\1\0\1\115\3\120\1\0\2\120\3\0\3\120"+
    "\1\360\1\120\1\356\1\347\1\0\1\120\22\0\3\120"+
    "\1\0\1\120\1\0\1\120\3\0\20\120\1\0\16\120"+
    "\1\0\1\120\1\356\1\347\1\361\60\120\3\125\1\0"+
    "\2\125\3\0\1\126\1\125\1\126\1\366\1\125\1\363"+
    "\1\125\1\0\1\125\22\0\3\125\1\0\1\125\1\0"+
    "\1\125\3\0\20\125\1\0\13\125\1\126\1\125\1\126"+
    "\1\0\1\125\1\363\1\125\1\367\61\125\1\365\1\125"+
    "\1\365\1\125\4\365\1\u0151\1\125\1\u0151\1\362\1\125"+
    "\1\363\1\125\1\364\1\u0152\22\365\3\125\1\365\1\125"+
    "\1\365\1\125\3\365\20\125\1\365\2\125\11\0\1\371"+
    "\1\0\1\371\76\0\1\374\1\0\1\374\66\0\1\377"+
    "\3\0\1\377\74\0\1\u0153\1\0\1\u0153\1\0\1\u0153"+
    "\1\0\1\u0153\14\0\2\u0153\2\0\1\u0153\4\0\1\u0153"+
    "\101\0\1\u0154\75\0\1\u0155\46\0\1\u0107\3\0\1\u0107"+
    "\74\0\1\31\1\0\1\31\1\0\4\31\11\0\1\31"+
    "\1\u011d\20\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\u0156\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\1\u0157\1\31\1\u0158\1\u0159\4\31\1\u015a\4\31"+
    "\1\u015b\4\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\u015a\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\u015c\12\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\u015d"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\31\1\u015e\20\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\16\31\1\u015f\3\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\13\31"+
    "\1\u0160\6\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\62\0\1\u014a\21\0\1\31\1\0\1\u0161"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\16\31\1\u0162\3\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\1\31\1\u0163\20\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\u0164\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\16\31"+
    "\1\u0165\3\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\u0166\12\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\u0167\12\31\1\u0168\6\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\16\31\1\u0169"+
    "\3\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\13\31\1\u016a\6\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\6\31\1\u016b\13\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u016c\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u016d\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u016e\6\31\1\u016f"+
    "\11\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\u016f\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\6\31\1\u0170\13\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\u0171\1\0"+
    "\4\31\11\0\22\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\5\31\1\u0172\14\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\10\31\1\u0173\11\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\u0173\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\31\1\u0174"+
    "\20\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\1\31\1\u0175\20\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\4\31\1\u0176\15\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\4\31\1\u0177\15\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\31\1\u0178"+
    "\20\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\13\31\1\u0179\6\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\16\31\1\u017a\3\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u017b\20\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\16\31\1\u017c"+
    "\3\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\5\31\1\u017d\14\31\3\0\1\u017e\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\31\1\u017f\20\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\31\0\1\u0180\102\0"+
    "\1\u0181\72\0\1\u0182\103\0\1\u0183\103\0\1\u0184\101\0"+
    "\1\u0185\43\0\1\u0185\55\0\1\u0186\60\0\1\u0187\102\0"+
    "\1\u0188\76\0\1\u0189\46\0\1\31\1\0\1\31\1\0"+
    "\2\31\1\u018a\1\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\u018b\3\31\1\u018c\15\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\16\31"+
    "\1\u018d\3\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\13\31\1\u018e\6\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\u018f\21\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u0190\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\5\0\1\u0191\2\0"+
    "\3\u0191\1\0\1\u014a\7\0\22\u0191\3\0\1\u0191\1\0"+
    "\1\u0191\1\0\3\u0191\20\0\1\u0191\32\0\1\u0192\61\0"+
    "\3\u014c\60\0\1\u014e\66\0\1\u0193\65\0\1\u0194\76\0"+
    "\1\u0195\33\0\11\125\1\u0151\1\125\1\u0151\1\362\1\125"+
    "\1\363\1\125\1\364\60\125\42\0\1\u0196\60\0\1\u0197"+
    "\57\0\1\31\1\0\1\31\1\0\4\31\11\0\5\31"+
    "\1\u0198\14\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\3\31\1\u0199\16\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\u019a"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\7\31\1\u019b\12\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\15\31\1\u019c\4\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\14\31"+
    "\1\u019d\5\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\1\u019e\21\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\12\31\1\u019f\7\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\17\31\1\u01a0\2\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\11\31\1\u01a1"+
    "\10\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\4\31\1\u01a2\15\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\13\31\1\u01a3\6\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u01a4\20\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\u01a5\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\15\31\1\u01a6"+
    "\4\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\5\31\1\u01a7\14\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\4\31\1\u01a8\15\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\13\31\1\u01a9\6\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\16\31\1\u01aa"+
    "\3\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\1\31\1\u01ab\20\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\13\31\1\u01ac\6\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u01ad\20\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\u01ae\21\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\1\31"+
    "\1\u01af\20\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\14\31\1\u01b0\5\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\u01b1"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\10\31\1\u01b2\11\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\u01b2\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\1\u01b3\21\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u01b4"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\11\31\1\u01b5\10\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\u01b6\21\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\11\31\1\u01b7\10\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\12\31\1\u01b8\7\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\u01b9\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\1\u01ba"+
    "\21\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\1\31\1\u01bb\20\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\13\31\1\u01bc\6\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u01bd\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\37\0\1\u01be\103\0"+
    "\1\u01bf\43\0\1\u01c0\6\0\1\u01c1\37\0\1\u01c2\35\0"+
    "\1\u01c3\126\0\1\u01c4\46\0\1\u01c5\100\0\1\u01c6\117\0"+
    "\1\u01c7\116\0\1\u01c8\75\0\1\u01c9\44\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\13\31\1\u01ca\6\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\16\31\1\u01cb"+
    "\3\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\5\31\1\u01cc\14\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\13\31\1\u01cd\6\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\16\31\1\u01ce\3\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\5\31\1\u01cf"+
    "\14\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\1\31\1\u01d0\20\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\u0191\1\0\1\u0191\1\0"+
    "\4\u0191\1\u01d1\1\0\1\u01d2\6\0\22\u0191\3\0\1\u0191"+
    "\1\0\1\u0191\1\0\3\u0191\20\0\1\u0191\35\0\1\u01d3"+
    "\102\0\1\u01d4\46\0\1\u01d5\2\0\3\u01d5\11\0\22\u01d5"+
    "\3\0\1\u01d5\1\0\1\u01d5\1\0\3\u01d5\20\0\1\u01d5"+
    "\13\0\2\u01d6\1\u01d7\127\0\1\u01d8\37\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\2\31\1\u01d9\17\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u01da"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\11\31\1\u01db\10\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\u01dc\21\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\u01dd\21\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\3\31\1\u01de\16\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\3\31\1\u01df"+
    "\16\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\2\31\1\u01e0\17\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\5\31\1\u01e1\14\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\21\31\1\u01e2\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\u01e3\1\0\4\31\11\0\22\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\16\31\1\u01e4\3\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\11\31"+
    "\1\u01e5\10\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\1\u01e6\21\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\6\31\1\u01e7\13\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\5\31\1\u01e8\14\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u01e9"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\14\31\1\u01ea\5\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\5\31\1\u01eb\14\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\11\31\1\u01ec\10\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\13\31\1\u01ed"+
    "\6\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\6\31\1\u01ee\13\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\31\1\u01ef\20\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\6\31\1\u01f0\13\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\35\0"+
    "\1\u01f1\50\0\1\u01f2\6\0\1\u01f3\37\0\1\u01f4\77\0"+
    "\1\u01f5\41\0\1\u01c1\37\0\1\u01c2\66\0\1\u01f6\63\0"+
    "\1\u01c8\100\0\1\u01f7\105\0\1\u01f8\77\0\1\u01f9\63\0"+
    "\1\u01c8\37\0\1\u01fa\62\0\1\u01fb\45\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\16\31\1\u01fc\3\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\u01fd\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u01fe"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\10\31\1\u01ff\11\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\u01ff\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\31\1\u0200\20\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u0201\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\14\31\1\u0202\5\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\13\0"+
    "\1\u01d1\111\0\1\u0203\111\0\1\u0204\56\0\1\u01d6\112\0"+
    "\1\u0205\56\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\10\31\1\u0206\11\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\u0206\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\16\31\1\u0207\3\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u0208\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u0209\20\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\16\31\1\u020a"+
    "\3\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\13\31\1\u020b\6\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\u020c\1\0"+
    "\4\31\11\0\22\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\6\31\1\u020d\13\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u020e\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\1\31\1\u020f\20\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\u0210\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\7\31\1\u0211"+
    "\12\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\14\31\1\u0212\5\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\4\31\1\u0213\15\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u0214\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\6\31\1\u0215\13\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\u0216\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\1\31\1\u0217"+
    "\20\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\36\0\1\u0218\101\0\1\u0219\55\0\1\u01f3\37\0"+
    "\1\u01f4\31\0\1\u021a\100\0\1\u01c8\107\0\1\u01f7\37\0"+
    "\1\u021b\51\0\1\u021c\126\0\1\u0218\41\0\1\u01fb\37\0"+
    "\1\u021d\27\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\1\31\1\u021e"+
    "\1\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\31\1\u021f\20\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\10\31\1\u0220\11\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\u0220\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\1\31\1\u0221\1\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\1\31\1\u0222"+
    "\1\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\7\31\1\u0223\12\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\44\0\1\u0224\47\0"+
    "\3\u0225\76\0\3\u0226\66\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\13\31\1\u0227\6\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\13\31\1\u0228\6\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u0229"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\u022a\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\6\31\1\u022b\13\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\22\31\3\0\1\31\1\0\1\31\1\0"+
    "\1\31\1\u022c\1\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u022d\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\5\31\1\u022e\14\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\5\31\1\u022f"+
    "\14\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\u0230\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\1\31\1\u0231"+
    "\1\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\31\1\u0232\20\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\u0233\1\0\4\31\11\0\22\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\14\0\1\u0218\37\0"+
    "\1\u0234\55\0\1\u01f3\104\0\1\u01c1\57\0\1\u021c\37\0"+
    "\1\u0235\27\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\22\31\3\0\1\31\1\0\1\31\1\0\1\31\1\u0236"+
    "\1\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\1\u0237\21\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\1\31\1\u0238\1\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\6\31\1\u0239\13\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\1\31\1\u023a\1\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\2\31\1\u023b\17\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\25\0\1\u023c\60\0\1\u023d"+
    "\2\0\3\u023d\3\u0225\1\u023e\5\0\22\u023d\3\0\1\u023d"+
    "\1\0\1\u023d\1\0\3\u023d\7\0\1\u023f\2\0\2\u023f"+
    "\4\0\1\u023d\13\0\3\u0226\24\0\1\u0240\41\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\11\31\1\u0241\10\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\6\31"+
    "\1\u0242\13\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\14\31\1\u0243\5\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\u0244"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\7\31\1\u0245\12\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\7\31\1\u0246\12\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\1\31"+
    "\1\u0247\20\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\u0248\12\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\2\31\1\u0249\17\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\7\31\1\u024a\12\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\1\31\1\u024b\1\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\7\31\1\u024c\12\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\22\31\3\0\1\31\1\0\1\31"+
    "\1\0\1\31\1\u024d\1\31\20\0\1\31\13\0\3\u023c"+
    "\31\0\1\340\34\0\1\u023d\1\0\1\u023d\1\0\4\u023d"+
    "\3\u024e\6\0\22\u023d\3\0\1\u023d\1\0\1\u023d\1\0"+
    "\3\u023d\7\0\1\u023f\2\0\2\u023f\4\0\1\u023d\5\0"+
    "\1\u024f\2\0\3\u024f\11\0\22\u024f\3\0\1\u024f\1\0"+
    "\1\u024f\1\0\3\u024f\20\0\1\u024f\5\0\1\u023d\2\0"+
    "\3\u023d\3\u024e\6\0\22\u023d\3\0\1\u023d\1\0\1\u023d"+
    "\1\0\3\u023d\7\0\1\u023f\2\0\2\u023f\4\0\1\u023d"+
    "\37\0\1\u0250\44\0\1\31\1\0\1\u0251\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\14\31\1\u0252\5\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\5\31\1\u0253\14\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\3\31\1\u0254\16\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\3\0\1\31\1\0\1\31\1\0\4\31\11\0\10\31"+
    "\1\u0255\11\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\u0255\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\5\31\1\u0256\14\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\5\31\1\u0257\14\31\3\0\1\31"+
    "\1\0\1\31\1\0\3\31\20\0\1\31\3\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\21\31\1\u0258\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\22\31\3\0"+
    "\1\31\1\0\1\31\1\0\1\31\1\u0259\1\31\20\0"+
    "\1\31\13\0\3\u024e\1\u025a\65\0\1\u024f\1\0\1\u024f"+
    "\1\0\4\u024f\3\u025b\6\0\22\u024f\3\0\1\u024f\1\0"+
    "\1\u024f\1\0\3\u024f\20\0\1\u024f\31\0\1\u025c\52\0"+
    "\1\31\1\0\1\31\1\0\4\31\11\0\6\31\1\u025d"+
    "\13\31\3\0\1\31\1\0\1\31\1\0\3\31\20\0"+
    "\1\31\3\0\1\31\1\0\1\31\1\0\4\31\11\0"+
    "\6\31\1\u025e\13\31\3\0\1\31\1\0\1\31\1\0"+
    "\3\31\20\0\1\31\3\0\1\31\1\0\1\31\1\0"+
    "\4\31\11\0\22\31\3\0\1\31\1\0\1\31\1\0"+
    "\1\31\1\u025f\1\31\20\0\1\31\3\0\1\31\1\0"+
    "\1\31\1\0\4\31\11\0\20\31\1\u0260\1\31\3\0"+
    "\1\31\1\0\1\31\1\0\3\31\20\0\1\31\5\0"+
    "\1\u0261\2\0\3\u0261\11\0\22\u0261\3\0\1\u0261\1\0"+
    "\1\u0261\1\0\3\u0261\20\0\1\u0261\5\0\1\u0262\2\0"+
    "\3\u0262\3\u025b\6\0\22\u0262\3\0\1\u0262\1\0\1\u0262"+
    "\1\0\3\u0262\7\0\1\u0263\2\0\2\u0263\4\0\1\u0262"+
    "\53\0\1\u0264\30\0\1\31\1\0\1\u0265\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\u0266\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\3\31"+
    "\20\0\1\31\3\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\22\31\3\0\1\31\1\0\1\31\1\0\1\31"+
    "\1\u0267\1\31\20\0\1\31\3\0\1\31\1\0\1\31"+
    "\1\0\4\31\11\0\1\u0268\21\31\3\0\1\31\1\0"+
    "\1\31\1\0\3\31\20\0\1\31\3\0\1\u0261\1\0"+
    "\1\u0261\1\0\4\u0261\3\u0269\6\0\22\u0261\3\0\1\u0261"+
    "\1\0\1\u0261\1\0\3\u0261\3\0\1\u026a\14\0\1\u0261"+
    "\3\0\1\u0262\1\0\1\u0262\1\0\4\u0262\3\u0269\6\0"+
    "\22\u0262\3\0\1\u0262\1\0\1\u0262\1\0\3\u0262\3\0"+
    "\1\u026a\3\0\1\u0263\2\0\2\u0263\4\0\1\u0262\5\0"+
    "\1\u0262\2\0\3\u0262\3\u0269\6\0\22\u0262\3\0\1\u0262"+
    "\1\0\1\u0262\1\0\3\u0262\3\0\1\u026a\3\0\1\u0263"+
    "\2\0\2\u0263\4\0\1\u0262\30\0\1\u026b\53\0\1\31"+
    "\1\0\1\31\1\0\4\31\11\0\16\31\1\u026c\3\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\13\0\3\u0269\45\0\1\u026a\101\0\1\u026d\53\0\1\u026e"+
    "\44\0\1\31\1\0\1\u026f\1\0\4\31\11\0\22\31"+
    "\3\0\1\31\1\0\1\31\1\0\3\31\20\0\1\31"+
    "\53\0\1\u0270\30\0\1\31\1\0\1\31\1\0\4\31"+
    "\11\0\11\31\1\u0271\10\31\3\0\1\31\1\0\1\31"+
    "\1\0\3\31\20\0\1\31\5\0\1\u0272\106\0\3\u0272"+
    "\42\0\1\u0273\33\0\3\u0273\1\0\1\u0274\24\0\1\u0275"+
    "\34\0\1\u0276\43\0\1\u0277\74\0\1\u0278\104\0\1\u0279"+
    "\74\0\1\u027a\104\0\1\u027b\74\0\1\u027c\104\0\1\u027d"+
    "\47\0\3\u027b\31\0\1\u027e\75\0\1\u027f\53\0\1\u027b"+
    "\162\0\1\u027b\1\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[30420];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


	/* error codes */
	private static final int ZZ_UNKNOWN_ERROR = 0;
	private static final int ZZ_NO_MATCH = 1;
	private static final int ZZ_PUSHBACK_2BIG = 2;

	/* error messages for the codes above */
	private static final String ZZ_ERROR_MSG[] = {
		"Unknown internal scanner error",		//$NON-NLS-1$
		"Error: could not match input",			//$NON-NLS-1$
		"Error: pushback value was too large"	//$NON-NLS-1$
	};

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\5\0\1\1\10\0\2\1\1\11\13\1\3\11\24\1"+
    "\1\11\12\1\4\11\1\1\2\11\1\1\1\11\2\1"+
    "\1\11\4\1\1\11\3\1\1\11\6\1\1\11\2\1"+
    "\1\11\2\1\1\11\2\1\2\11\1\1\24\11\2\1"+
    "\1\11\3\1\1\11\1\1\1\11\1\1\1\0\4\1"+
    "\1\0\1\11\6\1\2\11\1\0\2\1\2\0\1\1"+
    "\2\0\1\11\2\0\36\1\3\11\1\1\2\11\1\1"+
    "\12\0\2\1\1\11\2\1\2\11\1\1\1\0\2\11"+
    "\1\1\10\11\4\0\2\1\3\11\1\1\1\0\1\11"+
    "\3\0\2\1\3\0\3\1\1\0\1\11\2\0\1\11"+
    "\1\0\1\11\1\1\1\0\4\11\2\0\1\1\1\0"+
    "\12\1\1\0\41\1\1\11\1\1\12\0\6\1\3\11"+
    "\3\0\1\1\2\0\2\11\2\1\2\0\52\1\12\0"+
    "\7\1\2\0\1\11\4\0\46\1\4\0\1\11\7\0"+
    "\7\1\1\11\1\1\2\0\2\11\1\1\1\0\30\1"+
    "\3\0\1\11\5\0\1\11\1\0\7\1\3\0\22\1"+
    "\3\0\1\11\1\0\1\11\6\1\3\0\15\1\2\11"+
    "\6\1\5\0\15\1\3\0\11\1\3\0\4\1\4\0"+
    "\4\1\3\0\1\1\1\11\1\0\1\1\1\0\1\1"+
    "\14\0\1\11\1\0";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[639];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

	/** the input device */
	private java.io.Reader zzReader;

	/** the current state of the DFA */
	private int zzState;

	/** the current lexical state */
	private int zzLexicalState = YYINITIAL;

	/** this buffer contains the current text to be matched and is
		the source of the yytext() string */
	private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

	/** the textposition at the last accepting state */
	private int zzMarkedPos;

	/** the current text position in the buffer */
	private int zzCurrentPos;

	/** startRead marks the beginning of the yytext() string in the buffer */
	private int zzStartRead;

	/** endRead marks the last character in the buffer, that has been read
		from input */
	private int zzEndRead;

	/** number of newlines encountered up to the start of the matched text */
	private int yyline;

	/** the number of characters up to the start of the matched text */
	private int yychar;

	/**
	 * the number of characters from the last newline up to the start of the
	 * matched text
	 */
	private int yycolumn;

	/**
	 * zzAtBOL == true <=> the scanner is currently at the beginning of a line
	 */
	private boolean zzAtBOL = true;

	/** zzAtEOF == true <=> the scanner is at the EOF */
	private boolean zzAtEOF;

	/** denotes if the user-EOF-code has already been executed */
	private boolean zzEOFDone;

	/**
	 * The number of occupied positions in zzBuffer beyond zzEndRead.
	 * When a lead/high surrogate has been read from the input stream
	 * into the final zzBuffer position, this will have a value of 1;
	 * otherwise, it will have a value of 0.
	 */
	private int zzFinalHighSurrogate = 0;

  /* user code: */
	private final LinkedList commentList = new LinkedList();
	// https://bugs.eclipse.org/bugs/show_bug.cgi?id=514632
	// stores nested HEREDOC ids
	private final Stack<String> heredocIds = new Stack<>();
	private boolean asp_tags = false;
	private boolean short_tags_allowed = true;
	// XXX: "heredocIds" and "stack" are never reset
	private final StateStack stack = new StateStack();
	protected int commentStartPosition;

	private AST ast;

	public void setAST(AST ast) {
		this.ast = ast;
	}

	public PHPVersion getPHPVersion() {
		return PHPVersion.PHP5;
	}

	public void setInScriptingState() {
		yybegin(ST_IN_SCRIPTING);
	}

	public void resetCommentList() {
		commentList.clear();
	}

	/**
	 * Will only be filled when ast != null
	 */
	public LinkedList getCommentList() {
		return commentList;
	}

	/**
	 * Will only be added when ast != null
	 */
	protected void addComment(int type) {
		if (ast != null) {
			int leftPosition = getTokenStartPosition();
			Comment comment = new Comment(commentStartPosition, leftPosition + getTokenLength(), ast, type);
			commentList.add(comment);
		}
	}

	public void setUseAspTagsAsPHP(boolean useAspTagsAsPhp) {
		asp_tags = useAspTagsAsPhp;
	}

	public void setUseShortTags(boolean useShortTags) {
		short_tags_allowed = useShortTags;
	}

	private void pushState(int state) {
		stack.pushStack(zzLexicalState);
		yybegin(state);
	}

	private void popState() {
		yybegin(stack.popStack());
	}

	public int getCurrentLine() {
		return yyline;
	}

	protected int getTokenStartPosition() {
		return zzStartRead - _zzPushbackPos;
	}

	protected int getTokenLength() {
		return zzMarkedPos - zzStartRead;
	}

	public int getLength() {
		return zzEndRead - _zzPushbackPos;
	}

	private void handleCommentStart() {
		commentStartPosition = getTokenStartPosition();
	}

	private void handleLineCommentEnd() {
		addComment(Comment.TYPE_SINGLE_LINE);
	}

	private void handleMultilineCommentEnd() {
		addComment(Comment.TYPE_MULTILINE);
	}

	private void handlePHPDocEnd() {
		addComment(Comment.TYPE_PHPDOC);
	}

	protected void handleVarComment() {
		commentStartPosition = getTokenStartPosition();
		addComment(Comment.TYPE_MULTILINE);
	}

	private Symbol createFullSymbol(int symbolNumber) {
		Symbol symbol = createSymbol(symbolNumber);
		symbol.value = yytext();
		return symbol;
	}

	protected Symbol createSymbol(int symbolNumber) {
		int leftPosition = getTokenStartPosition();
		return new Symbol(symbolNumber, leftPosition, leftPosition + getTokenLength());
	}

	public int[] getParameters() {
		return new int[] { zzMarkedPos, _zzPushbackPos, zzCurrentPos,
				zzStartRead, zzEndRead, yyline, zzAtBOL ? 1 : 0,
				zzAtEOF ? 1 : 0, zzEOFDone ? 1 : 0, zzFinalHighSurrogate };
	}

	/**
	 * Parses a PHPDoc block comment. Underlying reader (zzReader) can be closed
	 * in the process (when EOF is reached).
	 *
	 * @return true when PHPDoc was parsed, false otherwise (false also implies
	 *         that underlying lexer was unavailable)
	 */
	protected boolean parsePHPDoc() {
		final IDocumentorLexer documentorLexer = getDocumentorLexer(zzReader);
		if (documentorLexer == null) {
			return false;
		}
		yypushback(zzMarkedPos - zzStartRead);
		int[] parameters = getParameters();
		documentorLexer.reset(zzReader, zzBuffer, parameters);
		Object phpDocBlock = documentorLexer.parse();
		commentList.add(phpDocBlock);
		reset(zzReader, documentorLexer.getBuffer(), documentorLexer.getParameters());
		return true;
	}

	protected IDocumentorLexer getDocumentorLexer(java.io.Reader reader) {
		return null;
	}

	/**
	 * Resets the {@code PhpAstLexer} properties to previous values, but leaves
	 * the lexical state unchanged. Be careful, method {@link #next_token()}
	 * also caches those properties using internal variables (zzCurrentPosL,
	 * zzMarkedPosL, zzBufferL, zzEndReadL) that should be accordingly resetted
	 * by the lexical rules calling
	 * {@link #reset(java.io.Reader, char[], int[])}. Also be careful that those
	 * internal variables could change from one version of JFlex to another.
	 *
	 * @param reader
	 * @param buffer
	 * @param parameters
	 */
	public void reset(java.io.Reader reader, char[] buffer, int[] parameters) {
		this.zzReader = reader;
		this.zzBuffer = buffer;
		this.zzMarkedPos = parameters[0];
		this._zzPushbackPos = parameters[1];
		this.zzCurrentPos = parameters[2];
		this.zzStartRead = parameters[3];
		this.zzEndRead = parameters[4];
		this.yyline = parameters[5];
		this.yychar = this.zzStartRead - this._zzPushbackPos;
		// XXX: never used
		this.yycolumn = 0;
		this.zzAtEOF = parameters[7] != 0;
		this.zzEOFDone = parameters[8] != 0;
		this.zzFinalHighSurrogate = parameters[9];
		// XXX: check if there's no side-effect to reset zzAtBOL
		// when zzAtEOF is false and zzMarkedPos is equal to zzStartRead.
		// One possible case would be that IDocumentorLexer#parse() matches
		// no text at all without being at EOF (i.e. the document lexer returns
		// a zero-length token), which of course would be totally broken...
		this.zzAtBOL = this.zzAtEOF ? false : (parameters[6] != 0);
	}


	/** the textposition at the last state to be included in yytext */
	private int _zzPushbackPos;

	/* The following fields are added in order to support the change in zzRefill */
	private String oldString = null;
	private boolean useOldString = false;
	private int startPos = 0;

	/**
	 * Creates a new scanner
	 *
	 * @param   in  the java.io.Reader to read input from.
	 */
  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public PHPAstLexer(java.io.Reader in) {
    this.zzReader = in;
  }


  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    char [] map = new char[0x110000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 234) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }


	/**
	 * Refills the input buffer.
	 *
	 * @return      <code>false</code>, iff there was new input.
	 *
	 * @exception   java.io.IOException  if any I/O-Error occurs
	 */
	private boolean zzRefill() throws java.io.IOException {

		if (useOldString) {
			String saveOldString = oldString;
			oldString = new String(zzBuffer, startPos, zzMarkedPos - startPos);
			if (saveOldString != null) {
				oldString = saveOldString + oldString;
			}
		}

		/* first: make room (if you can) */
		if (zzStartRead > 0) {
			zzEndRead += zzFinalHighSurrogate;
			zzFinalHighSurrogate = 0;
			System.arraycopy(zzBuffer, zzStartRead,
							zzBuffer, 0,
							zzEndRead-zzStartRead);

			/* translate stored positions */
			zzEndRead-= zzStartRead;
			zzCurrentPos-= zzStartRead;
			zzMarkedPos-= zzStartRead;
			_zzPushbackPos-= zzStartRead;
			startPos = 0;
			zzStartRead = 0;
		}

		/* is the buffer big enough? */
		if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
			/* if not: blow it up */
			char newBuffer[] = new char[zzBuffer.length*2];
			System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
			zzBuffer = newBuffer;
			zzEndRead += zzFinalHighSurrogate;
			zzFinalHighSurrogate = 0;
		}

		/* fill the buffer with new input */
		int requested = zzBuffer.length - zzEndRead;
		int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

		/* not supposed to occur according to specification of java.io.Reader */
		if (numRead == 0) {
			throw new java.io.IOException("Reader returned 0 characters.");
		}
		if (numRead > 0) {
			zzEndRead += numRead;
			/* If numRead == requested, we might have requested to few chars to
			   encode a full Unicode character. We assume that a Reader would
			   otherwise never return half characters. */
			if (numRead == requested) {
				if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
					--zzEndRead;
					zzFinalHighSurrogate = 1;
				}
			}
			/* potentially more input available */
			return false;
		}

		/* numRead < 0 ==> end of stream */
		return true;
	}


	/**
	 * Gets the next input character.
	 *
	 * @return      the next character of the input stream, EOF if the
	 *              end of the stream is reached.
	 * @exception   IOException  if any I/O-Error occurs
	 */
	private int yy_advance() throws java.io.IOException {

		/* standard case */
		if (zzCurrentPos < zzEndRead) return zzBuffer[zzCurrentPos++];

		/* if the eof is reached, we don't need to work hard */
		if (zzAtEOF) return YYEOF;

		/* otherwise: need to refill the buffer */

		String saveOldString = oldString;
		oldString = null;

		/* first: make room (if you can) */
		if (zzRefill()) {
			oldString = saveOldString;
			return YYEOF;
		}

		oldString = saveOldString;

		return zzBuffer[zzCurrentPos++];
	}


	/**
	 * Closes the input stream.
	 */
	public final void yyclose() throws java.io.IOException {
		zzAtEOF = true;            /* indicate end of file */
		zzEndRead = zzStartRead;  /* invalidate buffer    */

		if (zzReader != null)
			zzReader.close();
	}


	/**
	 * Resets the scanner to read from a new input stream.
	 * Does not close the old reader.
	 *
	 * All internal variables are reset, the old input stream
	 * <b>cannot</b> be reused (internal buffer is discarded and lost).
	 * Lexical state is set to <tt>ZZ_INITIAL</tt>.
	 *
	 * Internal scan buffer is resized down to its initial length, if it has grown.
	 *
	 * @param reader   the new input stream
	 */
	public final void yyreset(java.io.Reader reader) {
		zzReader = reader;
		zzAtBOL  = true;
		zzAtEOF  = false;
		zzEOFDone = false;
		zzEndRead = zzStartRead = 0;
		zzCurrentPos = zzMarkedPos = _zzPushbackPos = startPos = 0;
		zzFinalHighSurrogate = 0;
		oldString = null;
		yyline = yychar = yycolumn = 0;
		zzLexicalState = YYINITIAL;
		if (zzBuffer.length > ZZ_BUFFERSIZE)
			zzBuffer = new char[ZZ_BUFFERSIZE];
	}


	/**
	 * Returns the current lexical state.
	 */
	public final int yystate() {
		return zzLexicalState;
	}


	/**
	 * Enters a new lexical state
	 *
	 * @param newState the new lexical state
	 */
	public final void yybegin(int newState) {
		zzLexicalState = newState;
	}


	/**
	 * Returns the text matched by the current regular expression.
	 */
	public final String yytext() {
		return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
	}


	/**
	 * Returns the character at position <tt>pos</tt> from the
	 * matched text.
	 *
	 * It is equivalent to yytext().charAt(pos), but faster
	 *
	 * @param pos the position of the character to fetch.
	 *            A value from 0 to yylength()-1.
	 *
	 * @return the character at position pos
	 */
	public final char yycharat(int pos) {
		return zzBuffer[zzStartRead+pos];
	}


	/**
	 * Returns the length of the matched text region.
	 */
	public final int yylength() {
		return zzMarkedPos-zzStartRead;
	}


	/**
	 * Reports an error that occured while scanning.
	 *
	 * In a wellformed scanner (no or only correct usage of
	 * yypushback(int) and a match-all fallback rule) this method
	 * will only be called with things that "Can't Possibly Happen".
	 * If this method is called, something is seriously wrong
	 * (e.g. a JFlex bug producing a faulty scanner etc.).
	 *
	 * Usual syntax/scanner level error handling should be done
	 * in error fallback rules.
	 *
	 * @param   errorCode  the code of the errormessage to display
	 */
  private void zzScanError(int errorCode) {
		String message;
		try {
			message = ZZ_ERROR_MSG[errorCode];
		}
		catch (ArrayIndexOutOfBoundsException e) {
			message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
		}

    throw new Error(message);
	}


	/**
	 * Pushes the specified amount of characters back into the input stream.
	 *
	 * They will be read again by then next call of the scanning method
	 *
	 * @param number  the number of characters to be read again.
	 *                This number must not be greater than yylength()!
	 */
  public void yypushback(int number)  {
		if ( number > yylength() )
			zzScanError(ZZ_PUSHBACK_2BIG);

		zzMarkedPos -= number;
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos() {
		updateStartPos(zzMarkedPos);
	}


	/**
	 * user method - common.sse
	 */
	private void updateStartPos(int position) {
		startPos = position;
		oldString = null;
	}


	/**
	 * user method - common.sse
	 */
	public final boolean isEOF() {
		return zzAtEOF;
	}


  /**
   * Contains user EOF-code, which will be executed exactly once,
   * when the end of file is reached
   */
  private void zzDoEOF() throws java.io.IOException {
    if (!zzEOFDone) {
      zzEOFDone = true;
      yyclose();
    }
  }


	/**
	 * Resumes scanning until the next regular expression is matched,
	 * the end of input is encountered or an I/O-Error occurs.
	 *
	 * @return      the next token
	 * @exception   java.io.IOException  if any I/O-Error occurs
	 */
  public java_cup.runtime.Symbol next_token() throws java.io.IOException {
	int zzInput;
	int zzAction;

	// cached fields:
	int zzCurrentPosL;
	int zzMarkedPosL;
	int zzEndReadL = zzEndRead;
	char [] zzBufferL = zzBuffer;
	char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

	while (true) {
		zzMarkedPosL = zzMarkedPos;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          zzR = false;
          break;
        case '\r':
          yyline++;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
          }
          break;
        default:
          zzR = false;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
		zzAction = -1;

		zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


		zzForAction: {
			while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
				zzAction = zzState;
				zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
				}

			}
		}

			// store back cached position
			zzMarkedPos = zzMarkedPosL;

			if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
				zzAtEOF = true;
            zzDoEOF();
          { 	return createSymbol(sym.EOF);
 }
			}
			else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1: 
            { return createFullSymbol(ParserConstants.T_ENCAPSED_AND_WHITESPACE);
            }
          case 181: break;
          case 2: 
            { return createSymbol(ParserConstants.T_INLINE_HTML);
            }
          case 182: break;
          case 3: 
            { // do nothing
            }
          case 183: break;
          case 4: 
            { return createFullSymbol(ParserConstants.T_LNUMBER);
            }
          case 184: break;
          case 5: 
            { return createSymbol(ParserConstants.T_NEKUDA);
            }
          case 185: break;
          case 6: 
            { return createFullSymbol(ParserConstants.T_STRING);
            }
          case 186: break;
          case 7: 
            { return createSymbol(ParserConstants.T_PLUS);
            }
          case 187: break;
          case 8: 
            { 
            }
          case 188: break;
          case 9: 
            { return createSymbol(ParserConstants.T_DOLLAR);
            }
          case 189: break;
          case 10: 
            { yybegin(ST_DOUBLE_QUOTES);
	return createSymbol(ParserConstants.T_QUATE);
            }
          case 190: break;
          case 11: 
            { yybegin(ST_BACKQUOTE);
	return createSymbol(ParserConstants.T_BACKQUATE);
            }
          case 191: break;
          case 12: 
            { pushState(ST_IN_SCRIPTING);
	return createSymbol(ParserConstants.T_CURLY_OPEN);
            }
          case 192: break;
          case 13: 
            { return createSymbol(ParserConstants.T_SEMICOLON);
            }
          case 193: break;
          case 14: 
            { return createSymbol(ParserConstants.T_MINUS);
            }
          case 194: break;
          case 15: 
            { return createSymbol(ParserConstants.T_LGREATER);
            }
          case 195: break;
          case 16: 
            { return createSymbol(ParserConstants.T_NEKUDOTAIM);
            }
          case 196: break;
          case 17: 
            { return createSymbol(ParserConstants.T_OPEN_PARENTHESE);
            }
          case 197: break;
          case 18: 
            { return createSymbol(ParserConstants.T_CLOSE_PARENTHESE);
            }
          case 198: break;
          case 19: 
            { return createSymbol(ParserConstants.T_EQUAL);
            }
          case 199: break;
          case 20: 
            { return createSymbol(ParserConstants.T_NOT);
            }
          case 200: break;
          case 21: 
            { return createSymbol(ParserConstants.T_RGREATER);
            }
          case 201: break;
          case 22: 
            { return createSymbol(ParserConstants.T_TIMES);
            }
          case 202: break;
          case 23: 
            { return createSymbol(ParserConstants.T_DIV);
            }
          case 203: break;
          case 24: 
            { return createSymbol(ParserConstants.T_PRECENT);
            }
          case 204: break;
          case 25: 
            { return createSymbol(ParserConstants.T_REFERENCE);
            }
          case 205: break;
          case 26: 
            { return createSymbol(ParserConstants.T_OR);
            }
          case 206: break;
          case 27: 
            { return createSymbol(ParserConstants.T_KOVA);
            }
          case 207: break;
          case 28: 
            { return createSymbol(ParserConstants.T_COMMA);
            }
          case 208: break;
          case 29: 
            { return createSymbol(ParserConstants.T_OPEN_RECT);
            }
          case 209: break;
          case 30: 
            { return createSymbol(ParserConstants.T_CLOSE_RECT);
            }
          case 210: break;
          case 31: 
            { return createSymbol(ParserConstants.T_TILDA);
            }
          case 211: break;
          case 32: 
            { return createSymbol(ParserConstants.T_QUESTION_MARK);
            }
          case 212: break;
          case 33: 
            { return createSymbol(ParserConstants.T_AT);
            }
          case 213: break;
          case 34: 
            { if (!stack.isEmpty()) {
		popState();
	}
	return createSymbol(ParserConstants.T_CURLY_CLOSE);
            }
          case 214: break;
          case 35: 
            { yybegin(ST_SINGLE_QUOTE);
	return createSymbol(ParserConstants.T_SINGLE_QUATE);
            }
          case 215: break;
          case 36: 
            { handleCommentStart();
	yybegin(ST_ONE_LINE_COMMENT);
	// yymore();
            }
          case 216: break;
          case 37: 
            { yybegin(ST_IN_SCRIPTING);
	return createSymbol(ParserConstants.T_QUATE);
            }
          case 217: break;
          case 38: 
            { return createSymbol(ParserConstants.T_ENCAPSED_AND_WHITESPACE);
            }
          case 218: break;
          case 39: 
            { yybegin(ST_IN_SCRIPTING);
	return createSymbol(ParserConstants.T_SINGLE_QUATE);
            }
          case 219: break;
          case 40: 
            { yybegin(ST_IN_SCRIPTING);
	return createSymbol(ParserConstants.T_BACKQUATE);
            }
          case 220: break;
          case 41: 
            { yypushback(1);
	yybegin(ST_HEREDOC);
            }
          case 221: break;
          case 42: 
            { yypushback(1);
	popState();
            }
          case 222: break;
          case 43: 
            { popState();
	return createFullSymbol(ParserConstants.T_STRING);
            }
          case 223: break;
          case 44: 
            { yypushback(1);
	yybegin(ST_IN_SCRIPTING);
            }
          case 224: break;
          case 45: 
            { yybegin(ST_IN_SCRIPTING);
	return createFullSymbol(ParserConstants.T_STRING_VARNAME);
            }
          case 225: break;
          case 46: 
            { return createFullSymbol(ParserConstants.T_NUM_STRING);
            }
          case 226: break;
          case 47: 
            { yypushback(1);
	popState();
	return createSymbol(ParserConstants.T_ENCAPSED_AND_WHITESPACE);
            }
          case 227: break;
          case 48: 
            { return createSymbol(ParserConstants.T_QUATE);
            }
          case 228: break;
          case 49: 
            { return createSymbol(ParserConstants.T_BACKQUATE);
            }
          case 229: break;
          case 50: 
            { return createSymbol(ParserConstants.T_CURLY_OPEN);
            }
          case 230: break;
          case 51: 
            { popState();
	return createSymbol(ParserConstants.T_CLOSE_RECT);
            }
          case 231: break;
          case 52: 
            { return createSymbol(ParserConstants.T_CURLY_CLOSE);
            }
          case 232: break;
          case 53: 
            { // yymore();
            }
          case 233: break;
          case 54: 
            { String yytext = yytext();
	switch (yytext.charAt(yytext.length() - 1)) {
		case '?':
		case '%':
		case '>':
			yypushback(1);
			break;
		default:
			handleLineCommentEnd();
			yybegin(ST_IN_SCRIPTING);
	}
	// yymore();
            }
          case 234: break;
          case 55: 
            { if (asp_tags) {
		yybegin(ST_IN_SCRIPTING);
		//return T_OPEN_TAG;
	} else {
		return createSymbol(ParserConstants.T_INLINE_HTML);
	}
            }
          case 235: break;
          case 56: 
            { if (short_tags_allowed || yylength()>2) { /* yyleng>2 means it's not <? but <script> */
		yybegin(ST_IN_SCRIPTING);
		//return T_OPEN_TAG;
	} else {
		return createSymbol(ParserConstants.T_INLINE_HTML);
	}
            }
          case 236: break;
          case 57: 
            { return createFullSymbol(ParserConstants.T_DNUMBER);
            }
          case 237: break;
          case 58: 
            { return createSymbol(ParserConstants.T_CONCAT_EQUAL);
            }
          case 238: break;
          case 59: 
            { return createSymbol(ParserConstants.T_INC);
            }
          case 239: break;
          case 60: 
            { return createSymbol(ParserConstants.T_PLUS_EQUAL);
            }
          case 240: break;
          case 61: 
            { return createFullSymbol(ParserConstants.T_VARIABLE);
            }
          case 241: break;
          case 62: 
            { return createFullSymbol(ParserConstants.T_CONSTANT_ENCAPSED_STRING);
            }
          case 242: break;
          case 63: 
            { return createSymbol(ParserConstants.T_IF);
            }
          case 243: break;
          case 64: 
            { return createSymbol(ParserConstants.T_DO);
            }
          case 244: break;
          case 65: 
            { return createSymbol(ParserConstants.T_LOGICAL_OR);
            }
          case 245: break;
          case 66: 
            { return createSymbol(ParserConstants.T_AS);
            }
          case 246: break;
          case 67: 
            { return createSymbol(ParserConstants.T_DEC);
            }
          case 247: break;
          case 68: 
            { pushState(ST_LOOKING_FOR_PROPERTY);
	return createSymbol(ParserConstants.T_OBJECT_OPERATOR);
            }
          case 248: break;
          case 69: 
            { return createSymbol(ParserConstants.T_MINUS_EQUAL);
            }
          case 249: break;
          case 70: 
            { return createSymbol(ParserConstants.T_SR);
            }
          case 250: break;
          case 71: 
            { return createSymbol(ParserConstants.T_IS_GREATER_OR_EQUAL);
            }
          case 251: break;
          case 72: 
            { return createSymbol(ParserConstants.T_PAAMAYIM_NEKUDOTAYIM);
            }
          case 252: break;
          case 73: 
            { return createSymbol(ParserConstants.T_DOUBLE_ARROW);
            }
          case 253: break;
          case 74: 
            { return createSymbol(ParserConstants.T_IS_EQUAL);
            }
          case 254: break;
          case 75: 
            { return createSymbol(ParserConstants.T_IS_NOT_EQUAL);
            }
          case 255: break;
          case 76: 
            { return createSymbol(ParserConstants.T_IS_SMALLER_OR_EQUAL);
            }
          case 256: break;
          case 77: 
            { return createSymbol(ParserConstants.T_SL);
            }
          case 257: break;
          case 78: 
            { return createSymbol(ParserConstants.T_MUL_EQUAL);
            }
          case 258: break;
          case 79: 
            { return createSymbol(ParserConstants.T_DIV_EQUAL);
            }
          case 259: break;
          case 80: 
            { handleCommentStart();
	yybegin(ST_COMMENT);
            }
          case 260: break;
          case 81: 
            { if (asp_tags) {
		yybegin(YYINITIAL);
		return createSymbol(ParserConstants.T_SEMICOLON); /* implicit ';' at php-end tag */
	} else {
		return createSymbol(ParserConstants.T_INLINE_HTML);
	}
            }
          case 261: break;
          case 82: 
            { return createSymbol(ParserConstants.T_MOD_EQUAL);
            }
          case 262: break;
          case 83: 
            { return createSymbol(ParserConstants.T_AND_EQUAL);
            }
          case 263: break;
          case 84: 
            { return createSymbol(ParserConstants.T_BOOLEAN_AND);
            }
          case 264: break;
          case 85: 
            { return createSymbol(ParserConstants.T_OR_EQUAL);
            }
          case 265: break;
          case 86: 
            { return createSymbol(ParserConstants.T_BOOLEAN_OR);
            }
          case 266: break;
          case 87: 
            { return createSymbol(ParserConstants.T_XOR_EQUAL);
            }
          case 267: break;
          case 88: 
            { yybegin(YYINITIAL);
	return createSymbol(ParserConstants.T_SEMICOLON); /* implicit ';' at php-end tag */
            }
          case 268: break;
          case 89: 
            { yypushback(1);
	return createFullSymbol(ParserConstants.T_ENCAPSED_AND_WHITESPACE);
            }
          case 269: break;
          case 90: 
            { pushState(ST_LOOKING_FOR_VARNAME);
	return createSymbol(ParserConstants.T_DOLLAR_OPEN_CURLY_BRACES);
            }
          case 270: break;
          case 91: 
            { pushState(ST_IN_SCRIPTING);
	yypushback(yylength() - 1);
	return createSymbol(ParserConstants.T_CURLY_OPEN_WITH_DOLAR);
            }
          case 271: break;
          case 92: 
            { return createSymbol(ParserConstants.T_CHARACTER);
            }
          case 272: break;
          case 93: 
            { String yytext = yytext();
	int nb_pushback;
	if (yytext.charAt(yytext.length() - 2) == ';') {
		yytext = yytext.substring(0, yytext.length() - 2);
		nb_pushback = 2;
	} else {
		yytext = yytext.substring(0, yytext.length() - 1);
		nb_pushback = 1;
	}
	String heredoc = heredocIds.peek();
	if (yytext.equals(heredoc)) {
		yypushback(nb_pushback);
		heredocIds.pop();
		yybegin(ST_IN_SCRIPTING);
		return createSymbol(ParserConstants.T_END_HEREDOC);
	} else {
		// we must (at least) push the newline character back
		yypushback(1);
		yybegin(ST_HEREDOC);
	}
            }
          case 273: break;
          case 94: 
            { String yytext = yytext();
	int nb_pushback;
	if (yytext.charAt(yytext.length() - 2) == ';') {
		nb_pushback = 2;
	} else {
		nb_pushback = 1;
	}
	yypushback(nb_pushback);
	heredocIds.pop();
	yybegin(ST_IN_SCRIPTING);
	return createSymbol(ParserConstants.T_END_HEREDOC);
            }
          case 274: break;
          case 95: 
            { return createSymbol(ParserConstants.T_OBJECT_OPERATOR);
            }
          case 275: break;
          case 96: 
            { /* treat numbers (almost) as strings inside encapsulated strings */
	return createFullSymbol(ParserConstants.T_NUM_STRING);
            }
          case 276: break;
          case 97: 
            { handleMultilineCommentEnd();
	yybegin(ST_IN_SCRIPTING);
            }
          case 277: break;
          case 98: 
            { handlePHPDocEnd();
	yybegin(ST_IN_SCRIPTING);
            }
          case 278: break;
          case 99: 
            { if (asp_tags || yytext().charAt(0) != '%') { /* asp comment? */
		handleLineCommentEnd();
		yypushback(yylength());
		yybegin(ST_IN_SCRIPTING);
	}
            }
          case 279: break;
          case 100: 
            { String yytext = yytext();
	if ((yytext.charAt(1) == '%' && asp_tags)
		|| (yytext.charAt(1) == '?' && short_tags_allowed)) {
		yybegin(ST_IN_SCRIPTING);
		return createSymbol(ParserConstants.T_OPEN_TAG_WITH_ECHO);
	} else {
		return createSymbol(ParserConstants.T_INLINE_HTML);
	}
            }
          case 280: break;
          case 101: 
            { return createSymbol(ParserConstants.T_LOGICAL_XOR);
            }
          case 281: break;
          case 102: 
            { return createSymbol(ParserConstants.T_TRY);
            }
          case 282: break;
          case 103: 
            { return createFullSymbol(ParserConstants.T_EXIT);
            }
          case 283: break;
          case 104: 
            { return createSymbol(ParserConstants.T_FOR);
            }
          case 284: break;
          case 105: 
            { return createSymbol(ParserConstants.T_USE);
            }
          case 285: break;
          case 106: 
            { return createSymbol(ParserConstants.T_NEW);
            }
          case 286: break;
          case 107: 
            { return createSymbol(ParserConstants.T_LOGICAL_AND);
            }
          case 287: break;
          case 108: 
            { return createSymbol(ParserConstants.T_SR_EQUAL);
            }
          case 288: break;
          case 109: 
            { return createSymbol(ParserConstants.T_VAR);
            }
          case 289: break;
          case 110: 
            { return createSymbol(ParserConstants.T_IS_IDENTICAL);
            }
          case 290: break;
          case 111: 
            { return createSymbol(ParserConstants.T_IS_NOT_IDENTICAL);
            }
          case 291: break;
          case 112: 
            { return createSymbol(ParserConstants.T_SL_EQUAL);
            }
          case 292: break;
          case 113: 
            { if (parsePHPDoc()) {
	// https://bugs.eclipse.org/bugs/show_bug.cgi?id=316077
	// Reset the internal variables caching the values
	// previously resetted by parsePHPDoc().
	// Actually it would be enough to only reset zzEndReadL,
	// but do it cleanly...
	// Also be careful that those internal variables could
	// change from one version of JFlex to another.
	zzCurrentPosL = zzCurrentPos;
	zzMarkedPosL = zzMarkedPos;
	zzBufferL = zzBuffer;
	zzEndReadL = zzEndRead;
} else {
	handleCommentStart();
	yybegin(ST_DOCBLOCK);
}
            }
          case 293: break;
          case 114: 
            { yypushback(1);
	pushState(ST_VAR_OFFSET);
	return createFullSymbol(ParserConstants.T_VARIABLE);
            }
          case 294: break;
          case 115: 
            { String yytext = yytext();
	int nb_pushback;
	if (yytext.charAt(yytext.length() - 2) == ';') {
		yytext = yytext.substring(0, yytext.length() - 2);
		nb_pushback = 2;
	} else {
		yytext = yytext.substring(0, yytext.length() - 1);
		nb_pushback = 1;
	}
	int textLength = yytext.length();
	String heredoc = heredocIds.peek();
	int heredocLength = heredoc.length();
	if (textLength > heredocLength && yytext.substring(textLength - heredocLength, textLength).equals(heredoc)) {
		nb_pushback += heredocLength;
		// we need to remove the closing label from the symbol value
		yypushback(nb_pushback);
		yybegin(ST_END_HEREDOC);
		return createFullSymbol(ParserConstants.T_ENCAPSED_AND_WHITESPACE);
	}
	// we must (at least) push the newline character back
	yypushback(1);
            }
          case 295: break;
          case 116: 
            { return createSymbol(ParserConstants.T_ECHO);
            }
          case 296: break;
          case 117: 
            { return createSymbol(ParserConstants.T_ELSE);
            }
          case 297: break;
          case 118: 
            { return createSymbol(ParserConstants.T_EVAL);
            }
          case 298: break;
          case 119: 
            { return createSymbol(ParserConstants.T_CASE);
            }
          case 299: break;
          case 120: 
            { return createSymbol(ParserConstants.T_LIST);
            }
          case 300: break;
          case 121: 
            { handleCommentStart();
	handleMultilineCommentEnd();
            }
          case 301: break;
          case 122: 
            { return createSymbol(ParserConstants.T_ENDIF);
            }
          case 302: break;
          case 123: 
            { return createSymbol(ParserConstants.T_EMPTY);
            }
          case 303: break;
          case 124: 
            { return createSymbol(ParserConstants.T_BREAK);
            }
          case 304: break;
          case 125: 
            { return createSymbol(ParserConstants.T_ISSET);
            }
          case 305: break;
          case 126: 
            { return createSymbol(ParserConstants.T_THROW);
            }
          case 306: break;
          case 127: 
            { return createSymbol(ParserConstants.T_FINAL);
            }
          case 307: break;
          case 128: 
            { return createSymbol(ParserConstants.T_UNSET);
            }
          case 308: break;
          case 129: 
            { return createSymbol(ParserConstants.T_CONST);
            }
          case 309: break;
          case 130: 
            { return createSymbol(ParserConstants.T_CATCH);
            }
          case 310: break;
          case 131: 
            { return createSymbol(ParserConstants.T_CLONE);
            }
          case 311: break;
          case 132: 
            { return createSymbol(ParserConstants.T_CLASS);
            }
          case 312: break;
          case 133: 
            { return createSymbol(ParserConstants.T_ARRAY);
            }
          case 313: break;
          case 134: 
            { return createSymbol(ParserConstants.T_WHILE);
            }
          case 314: break;
          case 135: 
            { return createSymbol(ParserConstants.T_PRINT);
            }
          case 315: break;
          case 136: 
            { return createSymbol(ParserConstants.T_INT_CAST);
            }
          case 316: break;
          case 137: 
            { String yytext = yytext();
	int removeChars = (yytext.charAt(0) == 'b') ? 4 : 3;
	yytext = yytext.substring(removeChars).trim();    // for 'b<<<' or '<<<'
	heredocIds.push(yytext);
	yybegin(ST_START_HEREDOC);
	Symbol sym = createFullSymbol(ParserConstants.T_START_HEREDOC);
	sym.value = yytext;
	return sym;
            }
          case 317: break;
          case 138: 
            { yypushback(3);
	pushState(ST_LOOKING_FOR_PROPERTY);
	return createFullSymbol(ParserConstants.T_VARIABLE);
            }
          case 318: break;
          case 139: 
            { yybegin(ST_IN_SCRIPTING);
	//return T_OPEN_TAG;
            }
          case 319: break;
          case 140: 
            { return createSymbol(ParserConstants.T_ENDFOR);
            }
          case 320: break;
          case 141: 
            { return createSymbol(ParserConstants.T_ELSEIF);
            }
          case 321: break;
          case 142: 
            { /* not a keyword, hust for recognize constans.*/
	return createFullSymbol(ParserConstants.T_DEFINE);
            }
          case 322: break;
          case 143: 
            { return createSymbol(ParserConstants.T_STATIC);
            }
          case 323: break;
          case 144: 
            { return createSymbol(ParserConstants.T_SWITCH);
            }
          case 324: break;
          case 145: 
            { return createSymbol(ParserConstants.T_RETURN);
            }
          case 325: break;
          case 146: 
            { return createSymbol(ParserConstants.T_PUBLIC);
            }
          case 326: break;
          case 147: 
            { return createSymbol(ParserConstants.T_BOOL_CAST);
            }
          case 327: break;
          case 148: 
            { return createSymbol(ParserConstants.T_DOUBLE_CAST);
            }
          case 328: break;
          case 149: 
            { return createSymbol(ParserConstants.T_GLOBAL);
            }
          case 329: break;
          case 150: 
            { return createSymbol(ParserConstants.T_EXTENDS);
            }
          case 330: break;
          case 151: 
            { return createSymbol(ParserConstants.T_INCLUDE);
            }
          case 331: break;
          case 152: 
            { return createSymbol(ParserConstants.T_DEFAULT);
            }
          case 332: break;
          case 153: 
            { return createSymbol(ParserConstants.T_DECLARE);
            }
          case 333: break;
          case 154: 
            { return createSymbol(ParserConstants.T_FOREACH);
            }
          case 334: break;
          case 155: 
            { return createSymbol(ParserConstants.T_REQUIRE);
            }
          case 335: break;
          case 156: 
            { return createSymbol(ParserConstants.T_PRIVATE);
            }
          case 336: break;
          case 157: 
            { return createSymbol(ParserConstants.T_UNSET_CAST);
            }
          case 337: break;
          case 158: 
            { return createSymbol(ParserConstants.T_ARRAY_CAST);
            }
          case 338: break;
          case 159: 
            { return createSymbol(ParserConstants.T_ENDWHILE);
            }
          case 339: break;
          case 160: 
            { return createSymbol(ParserConstants.T_FUNCTION);
            }
          case 340: break;
          case 161: 
            { return createSymbol(ParserConstants.T_CONTINUE);
            }
          case 341: break;
          case 162: 
            { return createSymbol(ParserConstants.T_ABSTRACT);
            }
          case 342: break;
          case 163: 
            { return createSymbol(ParserConstants.T_STRING_CAST);
            }
          case 343: break;
          case 164: 
            { return createSymbol(ParserConstants.T_OBJECT_CAST);
            }
          case 344: break;
          case 165: 
            { return createSymbol(ParserConstants.T_FILE);
            }
          case 345: break;
          case 166: 
            { return createSymbol(ParserConstants.T_LINE);
            }
          case 346: break;
          case 167: 
            { return createSymbol(ParserConstants.T_ENDSWITCH);
            }
          case 347: break;
          case 168: 
            { return createSymbol(ParserConstants.T_INTERFACE);
            }
          case 348: break;
          case 169: 
            { return createSymbol(ParserConstants.T_PROTECTED);
            }
          case 349: break;
          case 170: 
            { return createSymbol(ParserConstants.T_CLASS_C);
            }
          case 350: break;
          case 171: 
            { return createSymbol(ParserConstants.T_ENDDECLARE);
            }
          case 351: break;
          case 172: 
            { return createSymbol(ParserConstants.T_ENDFOREACH);
            }
          case 352: break;
          case 173: 
            { return createSymbol(ParserConstants.T_INSTANCEOF);
            }
          case 353: break;
          case 174: 
            { return createSymbol(ParserConstants.T_IMPLEMENTS);
            }
          case 354: break;
          case 175: 
            { return createSymbol(ParserConstants.T_METHOD_C);
            }
          case 355: break;
          case 176: 
            { return createSymbol(ParserConstants.T_INCLUDE_ONCE);
            }
          case 356: break;
          case 177: 
            { return createSymbol(ParserConstants.T_REQUIRE_ONCE);
            }
          case 357: break;
          case 178: 
            { return createSymbol(ParserConstants.T_FUNC_C);
            }
          case 358: break;
          case 179: 
            { handleVarComment();
	//return createFullSymbol(ParserConstants.T_VAR_COMMENT);
            }
          case 359: break;
          case 180: 
            { return createSymbol(ParserConstants.T_HALT_COMPILER);
            }
          case 360: break;
		default:
            zzScanError(ZZ_NO_MATCH);
				}
			}
		}
	}

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String argv[]) {
    if (argv.length == 0) {
      System.out.println("Usage : java PHPAstLexer [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          java.nio.charset.Charset.forName(encodingName); // Side-effect: is encodingName valid? 
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        PHPAstLexer scanner = null;
        try {
          java.io.FileInputStream stream = new java.io.FileInputStream(argv[i]);
          java.io.Reader reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new PHPAstLexer(reader);
          while ( !scanner.zzAtEOF ) scanner.next_token();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
      }
    }
  }


}
